All credit goes to the device-auth team and contributors, hinting-api has adapted there metrics support for this project because it's awesome. 

Metrics
=======

Monitored metrics of `hinting-api` include these categories:
* Redis and DB Stats and Analysis
* Golang System Metrics

For visibility into the dashboards that are available, visit our Dashboard Group `PSC - EMS - device-auth` in Wavefront. 
The Dashboard is split into two groups:
* `Overview`
* `System`

## Dimensions
EMS device-auth have dimensions that are broken up into 2 categories:
* Application Tags
* Metric-dependent Dimensions

The application tags are further broken down as the following:
* `Application`: psc
* `Service`: device-auth
* `Cluster`: based on where EMS is deployed to (minikube | hub-dev-us | etc)
* `Shard`: currently set to none

Instance is included when instantiating a reporter as its `Source`, and is a unique identifier to distinguish the instance reporting.

Current environments enabled for 
* local development (minikube) 
* hub-dev-us
* hub-staging-us
* hub-prod-us
* hub-prod-eu
* hub-prod-ap

## RED Metrics
In Wavefront, RED metrics are key indicators of the health of your service, and are used to discover problem traces. Our RED metrics tag keys are:
* `http.status_code`
* `http.user_agent`
* `http.cache_hit`

## Monitoring Health:
There are 3 main ways we monitor the health of requests:
1. **Request rate and latency.** Total requests made over time are summed and visualized as an area. Latency is shown as a histogram and 95th percentile duration. If our latency starts to creep up, it may indicate that we need to scale, and should ensure that our max replicas are set correctly.
2. **Requests made per minute.** Knowing the current load on device-auth will give us insight on performance in relation to scale.
3. **Postgres Connections.** Since EMS is siphoning traffic away from `deviceServices`, it's important to know what the current amount of Postgres connections are, as having too many connections can easily cause an incident.

### Enforcement
With Enforcement mode, we want to be able to ensure our uptime, that our latency is low, and that our errors aren't outside the normal range. We also want to make sure that our connections to postgres are within a good range. Enforcement mode means that EMS is being used to provide authorization context for a device, so it's critical that we can ensure its stability.

## Redis and DB
Datapoints that are monitored in regards to Redis and DB internal within the application are the latency and active/idol connections for each service. 

## Golang System Metrics 
In the second dashboard group, `System`, are catch all datapoints provided by the golang `runtime` package.  This includes a plethora of memory and other miscellaneous stats. 

## Kubernetes Provided Metrics
Max pod restarts, currently running pods, and uptime are all metrics provided for free from mosaic.

## Redis (Elasticache)
Redis stats on a container level come out of the box as a direct interface with the AWS Elasticache instance.  Simply choose the region and then ems cluster to see related stats. Some sample graphs include:
* \# Clusters
* \# Nodes
* Hits + Misses by Cluster
* Avg CPU% by Cluster
* CurrConnections by Cluster
* Network and Memory Stats
